/*
 *  $Id: thttp.c,v 1.2 94/05/25 08:07:31 bert Exp $
 *
 *  Bill the Cat strikes again
 *  tfile interface for HTTP connections
 *  (part of diswww, a Discuss->WWW gateway)
 */

#ifndef lint
static char rcsid_thttp[] = "$Id: thttp.c,v 1.2 94/05/25 08:07:31 bert Exp $";
#endif

#include "proto.h"  /* the copyright notice is included in this file, too. */
#include <stdio.h>
#include <discuss/tfile.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <malloc.h>
#include <unistd.h>

#define SUCCESS 1

#define NL '\n'

struct thttp_state {
     char last_char;
};

/*
 *
 * thttp () -- This is the handler procedure that handles tfile requests.
 *
 */
int thttp (op, infop, info, argp, argn, result)
int op, *info, argn, *result;
char **infop, *argp;
{
     int numread,numwrite;
     struct thttp_state *ts;

     *result = 0;		/* optimist */
     ts = (struct thttp_state *) *infop;

     switch (op) {
     case TFOPEN:		/* argp is pointer to modes */
          return (0);

     case TFCLOSE:
          return (0);

     case TFREAD:
	  numread = read (*info, argp, argn);
	  if (numread < 0) {
	       *result = errno;
	       return (-1);
	  }
	  return(numread);

     case TFWRITE:
	  numwrite = write_quoted (*info, argp, argn);
	  if (numwrite < 0) {
	       *result = errno;
	       return (-1);
	  }
	  /* save last character written to file, so we can force NL */
	  ts -> last_char = argp [numwrite-1];
	  return(numwrite);

     case TFDESTROY:
	  free (*infop);
	  return (0);

     case TFCONTROL:
	  if (argn == TFC_FORCE_NL) {			/* force a NL at this point */
	       if (ts -> last_char != NL) {
		    write (*info, "\r\n", 2);
	       }
	  }
	  return (0);

     default:
	  *result = EBADF;
	  return (-1);
     }
}

/*
 *
 * http_tfile (tfs, us)
 *
 */
tfile http_tfile (desc)
int desc;
{
     struct stat buf;
     struct thttp_state *ts;

     if (fstat (desc, &buf) < 0)
	  return (NULL);

     ts = (struct thttp_state *) malloc (sizeof (struct thttp_state));
     ts -> last_char = 0;

     return (tcreate (buf.st_size, (char *) ts, desc, thttp));
}
